# coding=utf-8
#!/bin/python3

from ast import For
from asyncore import write
from cgitb import handler
import code
from dbm import dumb

from logging import exception
import numbers
import opcode
from pickle import FALSE
from signal import signal
# import socket
# import sys 
import os

import numpy as np
import re
import random
from time import sleep, time
import threading
from colorama import Fore, Back, Style
from colorama import init as colorama_init
from subprocess import Popen ,PIPE
#for open pty
import fcntl
import pty
import stat
import time
import termios
from xml.etree.ElementTree import SubElement
from scapy.all import hexdump
from subprocess import Popen 
#state machine
from greyhunter.machine import GreyhunterStateMachine
from greyhunter import fuzzing,fitness
from greyhunter.fuzzing import StateConfig, MutatorRandom, SelectorRandom, SelectorAll
#for bluetooth
from scapy.utils import *
from scapy.layers.bluetooth4LE import *
from scapy.layers.bluetooth import *
import scapy.all as scapy
from scapy.packet import Raw
# from scapy.layers.bluetooth import HCI_Hdr
HCI_CMD  = 0x01
ACL_DATA = 0x02
SCO_DATA = 0x03
HCI_EVT  = 0x04

#mutator methods
ZEROFILL    = 0x00
FULLFILL    = 0x01
RANDOMFILL  = 0x02

#pkt's  layer fields
# HCI_Cmd_Connect_Accept = 0x0409
# HCI_Cmd_Read_Remote_supported_Feature = 0x041b
# HCI_Cmd_Read_Remote_Extended_Feature = 0x041c
# HCI_Cmd_Remote_Name_Request = 0x0419

packet_send_log = [[0.0,0]]
packet_recv_log = [[0.0,0]]
packet_total_log = [[0.0,0]]

# open pty for btattach
def mkpty():
	#open pty
	master,slave = pty.openpty()
	slaveName = os.ttyname(slave)	
	print('slave device names read-write: ',master,slave)
	return master,slaveName

import select
def OpenBleDev():
    master,slaveName = mkpty()

    # slaveName = os.ttyname(slave)	

    iflag  = 0
    oflag  = 1
    cflag  = 2
    lflag  = 3
    # 使用raw模式，不识别命令字符，所有数据都进行发送
    # 对于只进行数据传输的串口来说，一般将其配置成Raw模式，对于该模式的的termios参数设置如下:	

    termAttr = termios.tcgetattr(master)
    termAttr[iflag] &= ~(termios.IGNBRK|termios.BRKINT|termios.PARMRK|termios.ISTRIP|termios.INLCR|termios.IGNCR|termios.ICRNL|termios.IXON)
    termAttr[oflag] &= ~termios.OPOST
    termAttr[lflag] &= ~(termios.ECHO|termios.ECHONL|termios.ICANON|termios.ISIG|termios.IEXTEN)
    termAttr[cflag] &= ~(termios.CSIZE|termios.PARENB)
    termAttr[cflag] |= termios.CS8
    termios.tcsetattr(master,termios.TCSANOW,termAttr)

    #setting NO_BLOCKING mode
    fl = fcntl.fcntl(master, fcntl.F_GETFL)
    fcntl.fcntl(master, fcntl.F_SETFL, fl | os.O_NONBLOCK)

    rl,wl,el    = select.select([master],[master],[],1)
    os.chmod(slaveName,stat.S_IRWXU|stat.S_IRWXG|stat.S_IRWXO)
    Command = "sudo ./tools/btattach -B "+str(slaveName)+ " -S 9600"
    Popen(Command,  shell=True )
    return wl[0]

states = [
    {'name':"INITIALIZING",'on_enter':'send_reset_reply', 'timeout': 1, 'on_timeout':'retry'},
    {'name':'CONNECT_REQ', 'on_enter':'send_connect_request', 'timeout': 0.5, 'on_timeout':'retry'},
    {'name':'COMPLETE_CON', 'on_enter':'send__connect_complete'},
    {'name':'FEATURE_RSP', 'on_enter':'send_feature_rsp', 'timeout': 0.5, 'on_timeout':'retry'},
    {'name':'EXT_FEATURE_RSP', 'on_enter':'send_ext_feature_rsp','timeout': 0.1, 'on_timeout':'retry'},
    {'name':'REMOTE_NAME_RSP', 'on_enter':'send_remote_name_rsp', 'timeout': 0.1, 'on_timeout':'retry'},
    {'name':'INFORMATION_REQ', 'on_enter':'send_information_req','timeout': 0.1, 'on_timeout':'retry'},
    {'name':'INFORMATION_RSP', 'on_enter':'send_information_rsp','timeout': 0.0000000000000000000001, 'on_timeout':'retry'},
    {'name':'INFORMATION_REQ_FIX', 'on_enter':'send_information_req_fix','timeout':0.0000000000000000000001, 'on_timeout':'retry'},
]

transitions = [
    # initial controller INITIALIZING  ->  INITIALIZING
    {'trigger': 'retry', 'source': 'INITIALIZING', 'dest': 'INITIALIZING'},
    # INITIALIZING -> CONNECT_REQ
    {'trigger': 'start', 'source': 'INITIALIZING', 'dest': 'CONNECT_REQ'},
    # CONNECT_REQ -> CONNECT_REQ
    {'trigger': 'retry', 'source': 'CONNECT_REQ', 'dest': 'CONNECT_REQ'},
    # CONNECT_REQ -> COMPLETE_CON
    {'trigger': 'update', 'source': 'CONNECT_REQ', 'dest': 'COMPLETE_CON',
    'conditions':'receive_AccessConnReq_rsp', 'after':'announce_connection'},
    # COMPLETE_CON -> FEATURE_RSP
    {'trigger': 'update', 'source': 'COMPLETE_CON', 'dest': 'FEATURE_RSP',
    'conditions':'receive_feature_req'},
    {'trigger': 'retry', 'source': 'FEATURE_RSP', 'dest': 'FEATURE_RSP'},
    # FEATURE_RSP -> INFORMATION_RSP
    {'trigger': 'update', 'source': 'FEATURE_RSP', 'dest': 'INFORMATION_RSP',
    'conditions':'receive_info_req'},

    # INFORMATION_RSP -> REMOTE_NAME_RSP
    {'trigger': 'update', 'source': 'INFORMATION_RSP', 'dest': 'REMOTE_NAME_RSP',
    'conditions':'receive_name_req'},

    # FEATURE_RSP -> EXT_FEATURE_RSP
    {'trigger': 'update', 'source': 'FEATURE_RSP', 'dest': 'EXT_FEATURE_RSP',
    'conditions':"receive_ext_feature_req"},
    
     # FEATURE_RSP -> REMOTE_NAME_RSP
    {'trigger': 'update', 'source': 'FEATURE_RSP', 'dest': 'REMOTE_NAME_RSP',
    'conditions':'receive_name_req'},

    {'trigger': 'retry', 'source': 'EXT_FEATURE_RSP', 'dest': 'EXT_FEATURE_RSP'},

    # {'trigger': 'update', 'source': 'FEATURE_RSP', 'dest': 'EXT_FEATURE_RSP'},
    {'trigger': 'update', 'source': 'EXT_FEATURE_RSP', 'dest': 'REMOTE_NAME_RSP'},
    {'trigger': 'retry', 'source': 'REMOTE_NAME_RSP', 'dest': 'REMOTE_NAME_RSP'},
    {'trigger': 'update', 'source': 'REMOTE_NAME_RSP', 'dest': 'INFORMATION_REQ'},
    #### 
    {'trigger': 'retry', 'source': 'INFORMATION_REQ', 'dest': 'INFORMATION_REQ'},
    {'trigger': 'update', 'source': 'INFORMATION_REQ', 'dest': 'INFORMATION_REQ_FIX',
    'conditions':'receive_info_rsp'},
    {'trigger': 'retry', 'source': 'INFORMATION_REQ_FIX', 'dest': 'INFORMATION_REQ_FIX'},
    {'trigger': 'update', 'source': 'INFORMATION_REQ_FIX', 'dest': 'INFORMATION_REQ_FIX'},
]

states_fuzzer_config = {
    # 'INITIALIZING': StateConfig(
    #     states_expected=[BTLE_DATA, BTLE_ADV_IND, BTLE_ADV_DIRECT_IND, BTLE_ADV_NONCONN_IND, BTLE_ADV_SCAN_IND,
    #                      BTLE_SCAN_RSP, BTLE_SCAN_REQ, BTLE_CONNECT_REQ],
    #     # Layers to be fuzzed before sending messages in a specific state (CVEs)
    #     fuzzable_layers=[BTLE_SCAN_REQ, BTLE_ADV],
    #     # What layers the fuzzing is applied (fuzzable layers)
    #     fuzzable_layers_mutators=[[MutatorRandom], [MutatorRandom]],
    #     # Type of mutators applied for each fuzzable layer
    #     fuzzable_layers_selections=[SelectorRandom, SelectorRandom],
    #     # Selection strategy
    #     fuzzable_layers_mutators_global_chance=10,  # 50  # 20  # Probability for the entire packet to be even fuzzed
    #     fuzzable_layers_mutators_chance_per_layer=[50, 50],  # Probability for each layer to be fuzzed
    #     fuzzable_layers_mutators_chance_per_field=[50, 50],  # Probability for each field to be fuzzed
    #     fuzzable_layers_mutators_exclude_fields=[[None], [None]],
    #     fuzzable_layers_mutators_lengths_chance=[5, 5],  # Probability for "len" fields to be fuzzed
    #     fuzzable_action_transition=None),
    'CONNECT_REQ': StateConfig(
        states_expected=[HCI_Cmd_Accept_Connection_Request],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[Raw],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=20,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[50],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[50],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None]],
        fuzzable_layers_mutators_lengths_chance=[5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
    'COMPLETE_CON': StateConfig(
        states_expected=[HCI_Cmd_Read_Remote_Supported_Features],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[Raw],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=10,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[60],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[60],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None], [None]],
        fuzzable_layers_mutators_lengths_chance=[5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
    'FEATURE_RSP': StateConfig(
        states_expected=[HCI_Cmd_Read_Remote_Extended_Features,L2CAP_InfoReq,HCI_Cmd_Remote_Name_Request],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[Raw],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=40,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[60],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[60],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None]],
        fuzzable_layers_mutators_lengths_chance=[5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),   
    'EXT_FEATURE_RSP': StateConfig(
        states_expected=[HCI_Cmd_Remote_Name_Request],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[Raw],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=20,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[50],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[50],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None]],
        fuzzable_layers_mutators_lengths_chance=[5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
    'REMOTE_NAME_RSP': StateConfig(
        states_expected=[L2CAP_Hdr,L2CAP_CmdHdr,L2CAP_InfoReq],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[Raw],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=20,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[60],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[60],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None], [None]],
        fuzzable_layers_mutators_lengths_chance=[5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
    'INFORMATION_REQ': StateConfig(
        states_expected=[L2CAP_InfoResp],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[ L2CAP_Hdr,L2CAP_CmdHdr , L2CAP_InfoReq],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom],[MutatorRandom], [MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom,SelectorRandom, SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=50,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[50,50, 50],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[50, 50, 50],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None],[None], [None]],
        fuzzable_layers_mutators_lengths_chance=[5, 5, 5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
    'INFORMATION_RSP': StateConfig(
        states_expected=[HCI_Cmd_Remote_Name_Request],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[ L2CAP_Hdr , L2CAP_CmdHdr, L2CAP_InfoResp],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom],[MutatorRandom], [MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom, SelectorRandom, SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=10,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[50, 50, 50],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[50, 50, 50],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None], [None],[None]],
        fuzzable_layers_mutators_lengths_chance=[5, 5, 5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
    'INFORMATION_REQ_FIX': StateConfig(
        states_expected=[None],
        # Layers to be fuzzed before sending messages in a specific state (CVEs)
        fuzzable_layers=[ L2CAP_Hdr,L2CAP_CmdHdr , L2CAP_InfoReq],
        # What layers the fuzzing is applied (fuzzable layers)
        fuzzable_layers_mutators=[[MutatorRandom],[MutatorRandom], [MutatorRandom]],
        # Type of mutators applied for each fuzzable layer
        fuzzable_layers_selections=[SelectorRandom,SelectorRandom, SelectorRandom],
        # Selection strategy
        fuzzable_layers_mutators_global_chance=20,  # 50  # 20  # Probability for the entire packet to be even fuzzed
        fuzzable_layers_mutators_chance_per_layer=[60,60, 60],  # Probability for each layer to be fuzzed
        fuzzable_layers_mutators_chance_per_field=[60, 60, 60],  # Probability for each field to be fuzzed
        fuzzable_layers_mutators_exclude_fields=[[None],[None], [None]],
        fuzzable_layers_mutators_lengths_chance=[5, 5, 5],  # Probability for "len" fields to be fuzzed
        fuzzable_action_transition=None),
        }
#packing pkt
def pkt_pack(*str_pkt):
    pkt = b''
    for a in str_pkt:
        # print(a)
        pkta = bytes.fromhex(str(a))
        pkt = pkt + pkta[::-1] # [::-1] reverse
    # hexdump(pkt)
    return pkt
def calc_field_len(*str_len): # len1 must be a string
    len_m = 0
    for l in str_len:
        len_m = len_m + len(bytes.fromhex(l))
    tmp_len_str = hex(len_m)[2:]
    if len(tmp_len_str) <= 2:
        return tmp_len_str.rjust(2,'0')
    else:
        return tmp_len_str.rjust(4,'0')

  
class BLECentralMethods(object):
    name = 'BLE'
    ptm_fd = None
    conn_handle = '0100'
    l2cap_cid = None
    machine = None

    #Default model paramaters
    master_address = '00:1a:7d:da:71:13'
    master_feature_set = 'le_encryption+le_data_len_ext'  # Model dependent
    slave_address = '08:D2:3E:E7:80:7D'
    conn_timeout = 100
    scan_timeout = 6 # Time in seconds for detect a crash during scanning
    recv_timeout = 1
    state_timeout = 3
    # Timers for name reference
    conn_supervision_timer = None  # type: threading.Timer
    conn_general_timer = None  # type: threading.Timer
    conn_req_timeout_timer = None  # type: threading.Timer
    fuzz_by_len = False
    fuzz_by_field = False

    enable_fuzzing = False
    enable_duplication = False
   # Internal variables
    master_address_raw = None
    slave_address_raw = None
    # config_file = 'ble_config.json'
    iterations = 0
    master_address_type = None
    pkt_send = []
    pkt_received = None
    pkt = None
    send_num_cnt = 0
    recv_num_cnt = 0
    pkt_num_cnt = 0
    peer_address = None
    last_gatt_request = None
    empty_pdu_count = 0
    master_gatt_server = None
    sent_packet = None
    pairing_starting = False
    # Internal Slave params
    slave_address_type = None
    slave_feature_set = None
    slave_ble_version = None
    slave_next_start_handle = None
    slave_next_end_handle = None
    slave_service_idx = None
    slave_characteristic_idx = None
    slave_characteristic = None
    slave_device = None  # type: BLEDevice
    slave_handles = None
    slave_handles_values = None
    slave_handles_idx = None
    slave_ever_connected = False
    slave_connected = False
    slave_connected_fix = False
    slave_crashed = False
    slave_l2cap_fragment = []
    slave_is_reset = False
    reset_pkt_num = None
    reset_pkt_tag = []
    def __init__(self, machine_states, machine_transitons,
                enable_fuzzing=None,
                enable_duplication=None,) -> None:
        
        self.ptm_fd = OpenBleDev()
        self.enable_duplication = enable_duplication
        self.enable_fuzzing = enable_fuzzing
        self.machine=GreyhunterStateMachine(states = machine_states,
                                                transitions=machine_transitons,
                                                print_transitions = True,
                                                print_timeout=True,
                                                initial= 'INITIALIZING',
                                                idle_state = 'INFORMATION_REQ',
                                                show_auto_transitions=True,
                                                show_conditions=True)
        self.machine.get_graph().draw('ble_central.png', prog='dot') 
    def state_change(self):
        if self.machine.source != self.machine.destination:
            self.update_timeout('conn_general_timer')
   
    def get_reset_evt_pkt(self):
        packets = rdpcap("./ble_reset.pcapng")
        # packets = rdpcap("/home/ble/Desktop/BTFuzz/reset.pcapng")
        pkt_evt = []
        pkt_evt_dict = {}  
        for i in range(int(packets.__len__()/2)):
            pkt_evt.append(packets[2*i-1])  
        for pkt_j in pkt_evt:
            # print(hex(j["HCI_Hdr"].opcode))
            pkt_evt_dict[pkt_j["HCI_Hdr"].opcode] = pkt_j[1]
        return pkt_evt_dict
    
    def add_packets(self,pkt):        
        self.pkt_send.append(pkt)


    def pkt_recvhandle(self, pkt):
        print(Fore.BLUE + "pkt_recvhandle")
        self.update_timeout('conn_supervision_timer')
        append_current_pkt = True
        pkts_to_process = []
        self.machine.add_packets(pkt=HCI_PHDR_Hdr(direction=0)/pkt)
        if pkt.len + 4 != pkt.__len__():
            pkt1 = bytes(pkt)[:pkt.len + 4]
            pkts_to_process.append(HCI_Hdr(pkt1))
            pkt2 = bytes(pkt)[pkt.len + 4:]
            pkts_to_process.append(HCI_Hdr(pkt2))
        else:
            pkts_to_process.append(pkt)

        for pkt_i in pkts_to_process:

            self.pkt = pkt_i
            pkt_type = pkt_i['HCI_Hdr'].type

            if pkt_type is HCI_CMD:
                if not self.slave_is_reset:
                    self.retry()
                #handle controller reject cmd 
                elif pkt_i['HCI_Hdr'].opcode == 0x040a:
                    self.send_cmd_status(pkt_i['HCI_Hdr'].opcode)
                    self.send_cmd_complete(pkt_i['HCI_Hdr'].opcode)
                    hcitool_cmd = "sudo hcitool -i hci1 cmd 0x03 0x01a 0x3" # set piscan
                    Popen(hcitool_cmd,shell=True)

                else:
                    pkt_OGF = pkt_i['HCI_Hdr'].opcode >> 10
                    if pkt_OGF == 0x3:

                        self.send_CBC_reply()
                    elif pkt_OGF == 0x1: #link control cmd
                        self.pkt_received = True                    
                        self.update()
                        self.pkt_received = False
                    elif pkt_OGF == 0x8:
                        self.send_cmd_complete(pkt_i['HCI_Hdr'].opcode)
            if fitness.Validate(pkt_i, self.state, states_fuzzer_config) == False:
                self.machine.report_anomaly(pkt=pkt_i)

                # hci_cmd_opcode = pkt['HCI_Hdr'].opcode
                # if hci_cmd_opcode == 0x0c03: # reset
                

            if pkt_type is ACL_DATA:
                # print(Fore.LIGHTRED_EX + "acl",type(pkt_i))
                # hexdump(pkt_i)
                # self.pkt.show()
                # l2cap_command_code = hex(pkt_i['L2CAP_Hdr'].code)
                
                self.pkt_received = True                    
                self.update()
                self.pkt_received = False
     

    def send(self,pkt,fuzz_by_field = False):
        pkt1 = pkt
        # select fuzz seed pkt
        if self.fuzz_by_len:            
            pkt1 = self.pkt_len_mutator(pkt,pkt.payload.name) #default the second layer field
        
        if fuzz_by_field:
            pkt1 = self.pkt_mutator(pkt, pkt.payload.name, RANDOMFILL)

        if self.enable_fuzzing :
            print(Fore.LIGHTCYAN_EX,"fuzzing\n")
            fuzzing.fuzz_packet_by_layers(pkt1, self.state, states_fuzzer_config, self)

        if self.enable_duplication :
            fuzzing.repeat_packet(self)
        
        # print(Fore.LIGHTWHITE_EX)
        self.machine.add_packets(pkt= HCI_PHDR_Hdr(direction=1)/pkt1)
        send_pkt = bytes(pkt1)        
        print(Fore.LIGHTWHITE_EX + "[TX--->]" )
        print(pkt1.summary())
        hexdump(send_pkt) 
        self.send_num_cnt += 1
        os.write(self.ptm_fd,send_pkt)
        if not (self.send_num_cnt & 0xf):
            packet_send_log.append([time.perf_counter(),self.send_num_cnt])
            tmp = self.send_num_cnt + self.recv_num_cnt
            packet_total_log.append([time.perf_counter(),tmp])
    
    def send_reset_reply(self):
        reply_pkt = self.get_reset_evt_pkt()
        if self.reset_pkt_num is None:
            self.reset_pkt_num = reply_pkt.__len__()
        print("tag_len:",self.reset_pkt_tag.__len__())
        print("reset_pkt_num:",self.reset_pkt_num)
        # if self.reset_pkt_tag.__len__() +3 == self.reset_pkt_num :
        if self.reset_pkt_tag.__len__() + 2  == self.reset_pkt_num :
            self.slave_is_reset = True
            self.start()
            self.reset_pkt_tag=[]
        # hexdump(self.pkt)
        # print(self.pkt.summary())

        key = self.pkt["HCI_Hdr"].opcode    
        if key == 3130:
            self.send_cmd_complete(key)
        else:
            self.send(reply_pkt[key])
        if key not in self.reset_pkt_tag:
            self.reset_pkt_tag.append(key)
     
    
    # Controller and Baseband Commands reply
    def send_CBC_reply(self):
        reply_pkt = self.get_reset_evt_pkt()
        key = self.pkt["HCI_Hdr"].opcode
        print("send pkt, jdr.opcode",key)
        if key == 3130:
            self.send_cmd_complete(key)
        else:
            self.send(reply_pkt[key])
       
    def send_connect_request(self):       
        if self.conn_req_timeout_timer is None:
            self.start_timeout("conn_req_timeout_timer", 0.1, self.inforeq_timeout_detected)
        if  self.master_address is None:
            self.master_address = str(RandMAC()).upper()
        # self.master_address_raw = ''.join(map(lambda x: chr(int(x, 16)), self.master_address.split(':')))
        self.master_address_raw = ''.join(map(lambda x: x, self.master_address.split(':')))
       
        hci_evt = "04"
        hci_evt_code = "04"    #connect request   
        device_type = '1c0000' 
        type_conn = '01' # acl connection
        hci_evt_len = calc_field_len(device_type, self.master_address_raw, type_conn)

        pkt = pkt_pack(hci_evt,hci_evt_code,hci_evt_len, self.master_address_raw ,device_type,type_conn)
        conn_pkt = HCI_Hdr(pkt)
        self.send(conn_pkt)
        # self.slave_is_reset = False
    def receive_AccessConnReq_rsp(self):
        if self.pkt_received:

             # 0x409 is Accept Connection
            if self.pkt['HCI_Hdr'].opcode == 0x409:
                return True
        return FALSE

    def announce_connection(self):
        self.disable_timeout('conn_req_timeout_timer')
        # waitting todo:
        self.start_timeout('conn_supervision_timer', self.conn_timeout / 100.0, self.timeout_detected)
        self.start_timeout('conn_general_timer', self.state_timeout, self.timeout_transition_detected)
        print(Fore.GREEN + '[!] BT Connection Established to target device')
        print(Fore.GREEN + '[!] Supervision timeout set to ' + str(self.conn_timeout / 100.0) + ' seconds')
        self.slave_ever_connected = True  # used to detect first connection
        self.slave_connected = True  # used to detect first connection
        
        
    def send__connect_complete(self):
        #1 C > H ,cmd_status
        # pkt0 = HCI_Event_Command_Status(status = 0x0, number = 0x2, opcode = 0x0409)
        # hci_evt_len = len(raw(pkt0))
        # pkt1 = HCI_Hdr(type=4) / HCI_Event_Hdr(code=0xf,len = hci_evt_len)/pkt0
        # self.send(pkt1)
        self.send_cmd_status(0x0409)# accept conn req

        #2 C > H , role change
        hci_evt = "04"
        hci_evt_code = '12' # role change
        status = '00' # success
        BD_addr = self.master_address_raw
        role_bd_addr = '00' # slave
        evt_len = calc_field_len(status, BD_addr, role_bd_addr)
        pkt2 = pkt_pack(hci_evt, hci_evt_code, evt_len, status, BD_addr, role_bd_addr)
        self.send(HCI_Hdr(pkt2))
        
        pkt_vendor_specific = pkt_pack('04','ff','04','01010026')
        self.send(HCI_Hdr(pkt_vendor_specific))
        #3 C > H , connect complete
        hci_evt = "04"
        hci_evt_code = '03' # connect complete
        status1 = '00' # success
        connect_handle = self.conn_handle
        BD_addr1 = self.master_address_raw
        link_type = "01" # acl link
        encryption_code = '00' # disabled
        evt_len1 = calc_field_len(status1, connect_handle, BD_addr1, link_type, encryption_code)
        pkt3 = pkt_pack(hci_evt, hci_evt_code, evt_len1, status1, connect_handle, BD_addr1,link_type, encryption_code )
        self.send(HCI_Hdr(pkt3))

    def receive_feature_req(self):
        if self.pkt_received and self.pkt["HCI_Hdr"].type == HCI_CMD:       
            if self.pkt['HCI_Hdr'].opcode == 0x041b:
                return True
        return FALSE

    def send_feature_rsp(self):
        #pkt1 .cmd status
      
        self.send_cmd_status(0x041b)
        self.send_max_slot_change()
     
        #pkt2 rsp features
        hci_evt = '04'
        evt_code = '0b'
        status = '00'
        connect_handle = self.conn_handle
        lmp_features = 'ffff8ffedbff5b87'
        evt_len = calc_field_len(status, connect_handle, lmp_features)
        pkt2 = pkt_pack(hci_evt, evt_code, evt_len, status,connect_handle, lmp_features[::-1])
        self.send(HCI_Hdr(pkt2))
    
    def receive_ext_feature_req(self):
        if self.pkt_received and self.pkt["HCI_Hdr"].type == HCI_CMD:     
            if self.pkt['HCI_Hdr'].opcode == 0x041c:
                return True
        return FALSE


    def send_ext_feature_rsp(self):
        #pkt0 cmd status
        self.send_cmd_status(0x041c)
        #pkt1 ext_feature rsp
        hci_evt = '04'
        evt_code = '23'
        status = '00'
        connect_handle = self.conn_handle
        page_num = '01'
        max_page_num = '01'
        lmp_features = '03000000000000'
        evt_len = calc_field_len(status, connect_handle, page_num, max_page_num, lmp_features)
        pkt1 = pkt_pack(hci_evt, evt_code, evt_len, status, page_num, max_page_num, lmp_features)
        self.send(HCI_Hdr(pkt1))

    def receive_name_req(self):
        if self.pkt_received and self.pkt["HCI_Hdr"].type == HCI_CMD:
    # 0x409 is Accept Connection
            if self.pkt['HCI_Hdr'].opcode == 0x0419:
                return True
        return FALSE

    def send_remote_name_rsp(self):
        #pkt0 cmd status
        self.send_cmd_status(0x0419) # remote name req
        #pkt1 number of complete
        hci_evt0 = '04'
        evt_code0 = '13'
        evt_len0 = '05'
        number_of_conn_handle = '01'
        conn_handle = self.conn_handle
        number_of_pkt = '0001'
        pkt1 = pkt_pack(hci_evt0, evt_code0, evt_len0, number_of_conn_handle, conn_handle, number_of_pkt)
        self.send(HCI_Hdr(pkt1))
        #pkt2 remote name req complete
        hci_evt = '04'
        evt_code = '07' #remote name req complete
        evt_len = 'ff' 
        status = '00'  #00:success
        bd_addr =  self.master_address_raw
        remote_name = 'ubuntu'
        remote_name_raw = ''.join(map(lambda x : hex(ord(x))[2:], remote_name[::-1]))
        zero_padding = (248-len(remote_name)) * '00'
        pkt2 = pkt_pack(hci_evt,evt_code, evt_len, status, bd_addr, remote_name_raw, zero_padding)
        self.send(HCI_Hdr(pkt2))

    def send_information_req(self):
        # a acl pkt 
        l2cap_info_req = L2CAP_CmdHdr(code = 0xa,id=0x1,len=2) / L2CAP_InfoReq(type = 2)
        pkt_l2cap =  L2CAP_Hdr(len = l2cap_info_req.__len__(), cid = 1 ) / l2cap_info_req
        conn_handle = int("0x"+self.conn_handle,16) 
        pkt = HCI_Hdr(type=2) / HCI_ACL_Hdr(BC = 0, PB = 2, handle =conn_handle,len = pkt_l2cap.__len__()) / pkt_l2cap 
        self.send(pkt)
        
        

    def send_information_rsp(self):
        l2cap_info_rsp = L2CAP_CmdHdr(code = 0xb,id=0x1,len=8) / L2CAP_InfoResp(type = 2, result = 0, data = b"\xb8\x02\x00\x00")
        pkt_l2cap = L2CAP_Hdr(len = l2cap_info_rsp.__len__(), cid = 1 ) / l2cap_info_rsp
        conn_handle = int("0x"+self.conn_handle,16)
        pkt = HCI_Hdr(type=2) / HCI_ACL_Hdr(BC = 0, PB = 2, handle = conn_handle,len = pkt_l2cap.__len__()) / pkt_l2cap 
        # pkt.show()
        self.send(pkt)

    def send_information_req_fix(self):
        # a acl pkt 
        l2cap_info_req = L2CAP_CmdHdr(code = 0xa,id=0x1,len=2) / L2CAP_InfoReq(type = 3)
        pkt_l2cap =  L2CAP_Hdr(len = l2cap_info_req.__len__(), cid = 1 ) / l2cap_info_req
        conn_handle = int("0x"+self.conn_handle,16) 
        pkt = HCI_Hdr(type=2) / HCI_ACL_Hdr(BC = 0, PB = 2, handle =conn_handle,len = pkt_l2cap.__len__()) / pkt_l2cap 
        self.send(pkt)
        self.slave_connected_fix = True
        
        pkt['L2CAP_Hdr'].cid = random.randint(0,10)
        pkt['L2CAP_Hdr'].len = 4
        pkt['L2CAP_Hdr'].payload = Raw(b"\x00\x00\x01\xc0")
        pkt["HCI_ACL_Hdr"].len = 8
        self.send(pkt)
        self.send_number_of_completed_pkt()
    # def send_information_rsp_fix(self):
    #     l2cap_info_rsp = L2CAP_CmdHdr(code = 0xb,id=0x1,len=8) / L2CAP_InfoResp(type = 2, result = 0, data = b"\xb8\x02\x00\x00")
    #     pkt_l2cap = L2CAP_Hdr(len = l2cap_info_rsp.__len__(), cid = 1 ) / l2cap_info_rsp
    #     conn_handle = int("0x"+self.conn_handle,16)
    #     pkt = HCI_Hdr(type=2) / HCI_ACL_Hdr(BC = 0, PB = 2, handle = conn_handle,len = pkt_l2cap.__len__()) / pkt_l2cap 
    #     # pkt.show()
    #     self.send(pkt)


    def receive_info_req(self):
        print("handle info_req")
        if self.pkt_received:         
            if L2CAP_InfoReq in self.pkt:
                return True
        return FALSE

    def receive_info_rsp(self):
        print("handle info_rsp")
        if self.pkt_received:         
            if L2CAP_InfoResp in self.pkt:
                return True
        return FALSE
    #cmd : hci_cmd, evt_code : response to hci_cmd
    def send_cmd_complete(self, cmd_code):
        #status 0:pending
        pkt0 = HCI_Event_Command_Complete(number = 2, opcode = cmd_code, status = 0x00)
        hci_evt_len = len(raw(pkt0))
        pkt1 = HCI_Hdr(type=4) / HCI_Event_Hdr(code=0x0e,len = hci_evt_len) / pkt0
        self.send(pkt1)

    #cmd : hci_cmd, evt_code : response to hci_cmd
    def send_cmd_status(self, cmd_code):
        #status 0:pending
        pkt0 = HCI_Event_Command_Status(status = 0x00, number = 0x2, opcode = cmd_code)
        hci_evt_len = len(raw(pkt0))
        pkt1 = HCI_Hdr(type=4) / HCI_Event_Hdr(code = 0x0f,len = hci_evt_len)/pkt0
        self.send(pkt1)

    def send_max_slot_change(self):
        pkt0 = pkt_pack('04','1b', '03',self.conn_handle, '05')
        self.send(HCI_Hdr(pkt0))

    def send_number_of_completed_pkt(self):
        pkt0 = pkt_pack('04','13', '05','01',self.conn_handle, '0001')
        self.send(HCI_Hdr(pkt0))

    def send_pcap_pkt(self):
        #get pkt from pacp
        tmp_pkts = scapy.rdpcap("/home/ble/Desktop/myFuzz/capture_m/connect.pcapng")
        #got a random packet from pacap 
        pkt1 = random.choice(tmp_pkts)
        if "HCI PHDR transport layer" in pkt1:
            pkt1 = pkt1.payload
        print(Fore.BLUE+"--->TX")
        hexdump(pkt1)
        self.send(pkt1)

    def pkt_len_mutator(self, pkt, field):
        fuzzed_pkt = pkt
        if fuzzed_pkt.haslayer(str(field)):
            #mutator field lenth:
            if fuzzed_pkt[str(field)].fields["len"]:
                tmp_len = fuzzed_pkt[str(field)].fields["len"]
                if tmp_len >> 8 :
                    fuzzed_pkt[str(field)].fields["len"] = random.randint(tmp_len,0xFFFF) #try to trigger overflow
                else:
                    fuzzed_pkt[str(field)].fields["len"] = random.randint(tmp_len,0xFF) #try to trigger overflow
                print(Fore.LIGHTBLACK_EX + "[+]Fuzzed lenth...")
        else:
            print(Fore.RED+"[-]not fount that field. nothing fuzzed" )
        return fuzzed_pkt
    # pkt is a packet from rdpcap()
    def pkt_mutator(self, pkt, field, mutate_way):
        # mytate_way are zer0fill, fullfill, random
        tmp_field = pkt[str(field)]
        # way = mutate_way 
        if mutate_way is ZEROFILL:
            pkt[str(field)] = self.MutatorZeroFill(tmp_field )
        if mutate_way is FULLFILL:
            pkt[str(field)] = self.MutatorFullFill(tmp_field)
        if mutate_way is RANDOMFILL:
            pkt[str(field)] = self.MutatorRandom(tmp_field)
            #mutator field by mutate_way
        
    def is_mac(s):
        regex_is_mac_str = re.compile("[A-Fa-f0-9]{2}:")
        return regex_is_mac_str.match(s) is not None

    def MutatorZeroFill(self, field):
        data = field
        for f in data.fields.keys():
            data.fields[f] = 0        
        return data


    def MutatorFullFill(self, field):
        data = field
        for f in data.fields.keys():
            data.fields[f] = 0xFF           
        return data

    def MutatorRandom(self, field):
        # mac_address = False
        type_sz = field.__len__() - field.payload.__len__()
        
            # if ':' in field and self.is_mac(field):  # Check if value is a mac addr string
            #     mac_address = True
            #     field = mac2str(field)  # convert mac string to bytes
            # data = bytearray(field)
            # cast = str
        #get the field (class : "dict") len
        data_len = field.fields.__len__()
        data = field.fields # a dict
        if data_len:            
                ran_num = random.randint(0, data_len -1 )  # Random index
                ran_list = random.sample(data.keys(),ran_num) # get random keys.
                for id in range(ran_num):
                    if data[ran_list[id]] >> 8 :
                        data[ran_list[id]] = random.randint(0, 0xFFFF)
                    else:
                        data[ran_list[id]] = random.randint(0, 0xFF)
                        
        # data = cast(data)
        # if mac_address:
        #     data = ("%02x:" * len(data))[:-1] % tuple(map(ord, data))  # Convert bytes back to mac string
        return data
    def write_pkt_cnt_log(self):
        pass
        # f = open("logs/recv_num_cnt.log", "a")
        # f.write(str(packet_recv_log))
        # f.write("\n")
        # f.close()
        # f = open("logs/send_num_cnt.log", "a")
        # f.write(str(packet_send_log))
        # f.write("\n")
        # f.close()
        # f = open("logs/total_num_cnt.log", "a")
        # f.write(str(packet_total_log))
        # f.write("\n")
        # f.close()
    def FuzzingLoop(self):
       
        print(Fore.YELLOW + '[!] BlueZ host Sniffing started...')
        # self.write_pkt_cnt_log()

        # cnt = 0
        rnt = 0
        # self.retry()
        while True:		
            try:  
                if self.ptm_fd:  

                    while True:
                        # print(Fore.LIGHTGREEN_EX+"[<]receiving data")
                        data1 = os.read(self.ptm_fd,1024)                        
                        rnt += 1
                        self.recv_num_cnt += 1
                        if not (self.recv_num_cnt & 0xf):
                            packet_recv_log.append([time.perf_counter(),self.recv_num_cnt])
                            tmp = self.send_num_cnt + self.recv_num_cnt
                            packet_total_log.append([time.perf_counter(),tmp])
                        print(Fore.LIGHTGREEN_EX + "[<]read %d data, rnt %d"% (len(data1),rnt))
                        if data1:
                            # parse the pkt
                            pkt = HCI_Hdr(data1)
                            print("[RX<---] ",pkt.summary())
                            hexdump(pkt)
                            pkt.show()
                            self.pkt_recvhandle(pkt)
                 
            except BlockingIOError as e:
                pass	
            except KeyboardInterrupt:
                print(Fore.RED + 'Model process stopped' + Fore.RESET)
                # self.write_pkt_cnt_log()
                self.machine.save_packets()
                self.disable_timeout('conn_supervision_timer')
                self.disable_timeout('conn_general_timer')
                self.disable_timeout('conn_req_timeout_timer')
                exit(0)
            except OSError:
                self.ptm_fd = None
                print(Fore.RED + 'Ptm-pts Error' + Fore.RESET)
            # try:
            #     # print(Fore.RED + 'disable conn_timer' + Fore.RESET)
            #     self.disable_timeout('conn_req_timeout_timer')
            #     # exit(0)

            #     # self.__init__(states,transitions)
            # except KeyboardInterrupt:
            #     print(Fore.RED + 'Model process stopped' + Fore.RESET)
            #     exit(0)
            # except OSError:
            #     pass
        
            # time.sleep(0.5)
    ### timer methods
    def timeout_detected(self):
        self.machine.reset_state_timeout()
        self.disable_timeout('conn_supervision_timer')
        self.disable_timeout('conn_general_timer')
        self.start_timeout('conn_req_timeout_timer', self.scan_timeout, self.inforeq_timeout_detected)
        print(Fore.LIGHTRED_EX + '[TIMEOUT] !!! Link timeout detected !!!')
        print(Fore.YELLOW + 'Reseting model to state ' + self.machine.idle_state)
        self.machine.reset_machine()
        # self.reset_vars()
        # self.write_pkt_cnt_log()
        self.machine.save_packets()

    def timeout_transition_detected(self):
        self.machine.reset_state_timeout()
        self.disable_timeout('conn_supervision_timer')
        self.disable_timeout('conn_general_timer')
        self.start_timeout('conn_req_timeout_timer', self.scan_timeout, self.inforeq_timeout_detected)
        print(Fore.YELLOW + '[TIMEOUT] !!! State global timeout !!!')
        print(Fore.YELLOW + 'Reseting model to state ' + self.machine.idle_state)
        self.machine.reset_machine()
        # self.write_pkt_cnt_log()
        # self.reset_vars()
        self.machine.save_packets()
    def disable_timeout(self, timer_name):
        timer = getattr(self, timer_name)
        if timer:
            timer.cancel()
            setattr(self, timer_name, None) 
   
    def update_timeout(self, timer_name):
            timer = getattr(self, timer_name)
            if timer:
                timer.cancel()
                self.start_timeout(timer_name, timer.interval, timer.function)
  
    def start_timeout(self, timer_name, seconds, callback):
        timer = getattr(self, timer_name)
        timer = threading.Timer(seconds, callback)
        setattr(self, timer_name, timer)
        timer.daemon = True
        timer.start()

    def inforeq_timeout_detected(self):
        if self.slave_ever_connected:
            self.disable_timeout('conn_general_timer')
            self.machine.report_crash()
            self.slave_ever_connected = False
            self.reset_vars()     
            self.slave_crashed = True
    def reset_vars(self):
        self.slave_connected = False
        self.slave_connected_fix = False
        self.iteration()
    def iteration(self):

        fitness.Transition(reset=True)
        state_transitions = fitness.TransitionLastCount
        iterationTime = fitness.Iteration()

        if fitness.IssuePeriod > 0:
            issuePeriod = fitness.IssuePeriod
        else:
            issuePeriod = float('inf')

        print(Back.WHITE + Fore.BLACK +
              "IssueCount:" + str(fitness.IssueCounter) + ' IssuePeriod:{0:.3f}'.format(issuePeriod)
              + ' Transitions:' + str(state_transitions) + ' IterTime:{0:.3f}'.format(
                    iterationTime) + ' TotalIssues: '
              + str(fitness.IssuesTotalCounter))

        # send_fitness(fitness.IssueCounter, issuePeriod, state_transitions, iterationTime, self.iterations,
        #              fitness.IssuesTotalCounter)

        self.iterations += 1
        print("iteratons:",self.iterations)
        if self.iterations == 1000000:
            # print()
            exit(0)

 
if __name__ == "__main__":
    
    f1 = BLECentralMethods(machine_states=states, 
                           machine_transitons=transitions,
                           enable_fuzzing= True,
                           enable_duplication= False)
    # f1.__init__()
    sleep(1)
    f1.FuzzingLoop()
